/*******************************************************
Project :   
Version : 1.0
Date    : 19.05.2015
Author  :  ..
Company : 
Comments: http://ra4cbh.qrz.ru/


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*******************************************************/

#include <mega8.h>
#include <stdio.h>
#include <delay.h>

// I2C Bus functions
#include <i2c.h>

// DS1307 Real Time Clock functions
#include <ds1307.h>

// Alphanumeric LCD functions
#include <alcd.h>

#include "meh.h"
#include "meh.c"

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{    

if (Error==0) TimeHoda++;
if (Poliw==1) {TimeHoda++; TimeW++;} 

  if ((sek/2 && sek%2) || (sek==0)) dwtoch=':';  
  else dwtoch=' '; 
}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (0<<DDB2) | (0<<DDB1) | (0<<DDB0);
// State: Bit7=T Bit6=T Bit5=P Bit4=P Bit3=P Bit2=T Bit1=T Bit0=T 
PORTB=(0<<PORTB7) | (0<<PORTB6) | (1<<PORTB5) | (1<<PORTB4) | (1<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Port C initialization
// Function: Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=Out Bit0=Out 
DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (1<<DDC1) | (1<<DDC0);
// State: Bit6=T Bit5=T Bit4=T Bit3=P Bit2=P Bit1=0 Bit0=0 
PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (1<<PORTC3) | (1<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);

// Port D initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=Out Bit3=In Bit2=In Bit1=In Bit0=In 
DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (1<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
// State: Bit7=T Bit6=T Bit5=T Bit4=0 Bit3=P Bit2=T Bit1=T Bit0=T 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (1<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 7.813 kHz
TCCR0=(1<<CS02) | (0<<CS01) | (1<<CS00);
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Disconnected
// OC1B output: Disconnected
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (0<<CS10);
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0<<AS2;
TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (0<<CS22) | (0<<CS21) | (0<<CS20);
TCNT2=0x00;
OCR2=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (1<<TOIE0);

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);

// USART initialization
// USART disabled
UCSRB=(0<<RXCIE) | (0<<TXCIE) | (0<<UDRIE) | (0<<RXEN) | (0<<TXEN) | (0<<UCSZ2) | (0<<RXB8) | (0<<TXB8);

// Analog Comparator initialization
// Analog Comparator: Off
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
SFIOR=(0<<ACME);

// ADC initialization
// ADC disabled
ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);

// SPI initialization
// SPI disabled
SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);

// TWI initialization
// TWI disabled
TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);

// Bit-Banged I2C Bus initialization
// I2C Port: PORTC
// I2C SDA bit: 5
// I2C SCL bit: 4
// Bit Rate: 100 kHz
// Note: I2C settings are specified in the
// Project|Configure|C Compiler|Libraries|I2C menu.
i2c_init();

// DS1307 Real Time Clock initialization
// Square wave output on pin SQW/OUT: Off
// SQW/OUT pin state: 0
rtc_init(0,0,0);

// Alphanumeric LCD initialization
// Connections are specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTB Bit 6
// RD - PORTB Bit 7
// EN - PORTD Bit 5
// D4 - PORTD Bit 6
// D5 - PORTD Bit 7
// D6 - PORTB Bit 0
// D7 - PORTB Bit 2
// Characters/line: 16
lcd_init(16);


// Global enable interrupts
#asm("sei")

par3=0;
Error=0;
TimeHoda=0;
KB3=0;
chetchikW=0;
lcd_clear();

   
lcd_gotoxy(0,0);       
lcd_putsf("aa..."); 

PKlapan1; 
           
while (TimeHoda<TimeWoda*4) {  
if (PIND.3==0) {chetchikW++;};
delay_ms(3);

  lcd_gotoxy(0,1);                                      
  sprintf(lcd_buf, "Boa: %2i ce.   ", TimeWoda-TimeHoda/4);
  lcd_puts(lcd_buf); };        

if (chetchikW==0) PKlapan0; 

TimeHoda=0;
TimeHodaK=0;
PORTC.0=Nap;

PMotor1; 

lcd_gotoxy(0,1);
lcd_putsf("B. peyopa");

while (TimeHoda<3*4) {
if (PINB.3==0) {
TimeHodaK++;

  lcd_gotoxy(0,1);     
  sprintf(lcd_buf, "Oae:%3i ce.", 3-TimeHoda/4);  
  lcd_puts(lcd_buf); }}

TimeHoda=0;

while (PORTC.1==1 && TimeHoda<TimeDwivenija*4) {

if (TimeHodaK>0) { 
  lcd_gotoxy(0,1);     
  sprintf(lcd_buf, "Oe:%3i ce. ", TimeDwivenija-TimeHoda/4); 
  lcd_puts(lcd_buf);

PORTC.0=~PORTC.0;
delay_ms(800);
PORTC.0=~PORTC.0;
TimeHodaK=0;}
        
  if (PINB.3==1 && KB3==0) KB3=1;      
  if (PINB.3==0 && KB3==1) KB3=2;    
  
  if (KB3==2) 
  {PORTC.0 = ~PORTC.0;          
  Nap=PORTC.0;  
  PMotor0;  
  KB3=0;
  break;}
  
  lcd_gotoxy(0,1);     
  sprintf(lcd_buf, "Peyop:%3i ce.", TimeDwivenija-TimeHoda/4);
  lcd_puts(lcd_buf);}

           
if (chetchikW>0 && PORTC.1!=1) {          
lcd_gotoxy(0,1);
lcd_putsf("ceo!        ");
Error=-1; }
if (chetchikW==0) { 
lcd_gotoxy(0,1);
lcd_putsf("Oa: e o");
Error=1; };   
      
if (PORTC.1==1) { 
if (chetchikW==0) lcd_gotoxy(0,0); else       
lcd_gotoxy(0,1);
lcd_putsf("Oa: peyop");
Error=1; };
PKlapan0; 
PMotor0;     
delay_ms(900); 
if ((Revim==-1) || (Revim==0) || (Revim>3)) Revim=1;
if ((chetchikWZadan==0) || (chetchikWZadan<0)) chetchikWZadan=300;
if ((chetchikWZadan3==0) || (chetchikWZadan3<0)) chetchikWZadan3=300;

Poliw=0;
KB3=0;
KD3=0;
chetchikW=0; 
if (Error!=1)
lcd_clear();
                        

while (1) {     
if (Error==1) break; 
     
  rtc_get_time(&hour,&min,&sek);
  rtc_get_date(&week_day, &day,&month,&year);
      

  if (month==0 && year==0) {
  rtc_set_date(5,8,7,16);
  rtc_set_time(6,36,11);  
  hour3=6; 
  min3=0;}    
   

  if (Revim!=3) {                    
  lcd_gotoxy(0,1); 
  lcd_putchar(hour/10+0x30);
  lcd_putchar(hour%10+0x30);  
  lcd_gotoxy(3,1); 
  lcd_putchar(min/10+0x30);
  lcd_putchar(min%10+0x30);
  lcd_gotoxy(6,1);
  lcd_putchar(day/10+0x30);
  lcd_putchar(day%10+0x30);
  lcd_putchar('.');
  lcd_putchar(month/10+0x30);
  lcd_putchar(month%10+0x30);
  lcd_putchar('.');
  lcd_putchar(year/10+0x30);
  lcd_putchar(year%10+0x30);
  lcd_gotoxy(2,1);   
  lcd_putchar(dwtoch);   
  } else  {  
  lcd_gotoxy(5,1);
  lcd_putsf("    ");      
  lcd_gotoxy(9,1);
  lcd_putchar(hour/10+0x30);
  lcd_putchar(hour%10+0x30);  
  lcd_gotoxy(12,1);
  lcd_putchar(min/10+0x30);
  lcd_putchar(min%10+0x30);      
  lcd_gotoxy(11,1);   
  lcd_putchar(dwtoch);  
  lcd_gotoxy(0,1);
  lcd_putchar(hour3/10+0x30);
  lcd_putchar(hour3%10+0x30);  
  lcd_putchar(':');
  lcd_putchar(min3/10+0x30);
  lcd_putchar(min3%10+0x30); }
  
     if (min==60||min==255) min=0;
     if (hour==24||hour==255) hour=0;  
           
  if (menu==0) {
  Schetchik();
                
  if (Poliw==1) {
  if (PINB.3==1 && KB3==0) KB3=1;      
  if (PINB.3==0 && KB3==1) KB3=2;      
  
  if (KB3==2) 
  {PORTC.0 = ~PORTC.0;  
  KB3=0;
  delay_ms(180);           
  Nap=PORTC.0;   
  
  TimeHoda=0;}
 
   if (TimeHoda>TimeDwivenija*3.84) {  
      Stop();  
      lcd_gotoxy(1,0);
      lcd_putsf("E-Pe"); }}        
  
  lcd_gotoxy(15,1); 
  if (PORTC.0==0) lcd_putchar('<');
  else lcd_putchar('>');
      
  lcd_gotoxy(0,0);     
  sprintf(lcd_bufR, "%i", Revim);
  lcd_puts(lcd_bufR);
                
      if (Revim==2) {
      if (chetchikW>=chetchikWZadan) {
      Stop();
      lcd_gotoxy(1,0);
      lcd_putsf("cex:"); }}
  
      if (Revim==3) {
      if (chetchikW>=chetchikWZadan3) {
      Stop();
      lcd_gotoxy(1,0);
      lcd_putsf("cex:"); }
      
      if (hour==hour3 && min==min3 && par3==0) Start();      
      }}          
         
  
  if (menu==1) {       
      lcd_gotoxy(0,0);
      lcd_putsf("                ");  
      lcd_gotoxy(x,0);
      lcd_putchar(0xDA);
      lcd_gotoxy(x+1,0);
      lcd_putchar(0xDA);}

if (Revim==3 && par3>0) { 
         
 if (dwtoch==":") {  
 
 if (par3==1) {  
  lcd_gotoxy(0,1);
  lcd_putchar(hour3/10+0x30);
  lcd_putchar(hour3%10+0x30);} 
 
 if (par3==2) {
  lcd_gotoxy(3,1);
  lcd_putchar(min3/10+0x30);
  lcd_putchar(min3%10+0x30);}  
 } else {
 if (par3==1) {  
  lcd_gotoxy(0,1);
  lcd_putsf("  ");}  
 if (par3==2) {
  lcd_gotoxy(3,1);
  lcd_putsf("  ");}   
}}  
  
      
  if ((Poliw==0) && (PINC.3==0) && (PINB.4==0)) {
  delay_ms(80);
  menu=1;}    
  
  if ((Poliw==0) && (PINC.2==0) && (PINC.3==0)) {
       
  if (Revim!=3) {     
  chetchikW=0;
  delay_ms(80); } else {
 if (chetchikW!=0) {
  chetchikW=0;
  delay_ms(80); } else {
 if (par3>2) par3=0; else par3++;
 } } }  

  if (PINB.5==0) {
  delay_ms(100); 
  if (Poliw==0) kod='p';
  else kod='s'; }  
       
  if ((PINB.4==0) && (Poliw==0)) {
  delay_ms(80);
  kod='r';}     
  
  if ((PINC.2==0) && (Poliw==0)) {
  delay_ms(80);
  kod='+';}  
  
  if ((PINC.3==0) && (Poliw==0)) {
  delay_ms(80);
  kod='-';}      
 
 switch (kod) {
  case 'p': {    
   Start();       
   break;};      
          
  case 's': {       
   Stop();                
   break;}; 
   
  case 'r': {   
  if (menu==0) { 
  if (Revim>=3) Revim=1; else 
  Revim=Revim+1;     
   
  lcd_gotoxy(0,0);
  if (Revim==1) lcd_putsf("1 Pyo pe  ");
  if (Revim==2) lcd_putsf("2 o cy   "); 
  if (Revim==3) lcd_putsf("3 o pacca ");
  
  delay_ms(330);   
  Schetchik();
  lcd_gotoxy(1,0);    
  lcd_putsf("     :");} else {   
        switch (x) {
        case 0: {x=3; break;};           
        case 3: {x=6; break;};
        case 6: {x=9; break;};
        case 9: {x=12; break;};
        case 12: {x=0; break;}; }
   kod='?';} break;}; 
   
  case '+': { 
  if (menu==0) {   
  if (Revim==2) {   
  chetchikWZadan = chetchikWZadan + 100;
  Schetchik();}   
  if (Revim==3) { 
  if (par3==0) {  
  chetchikWZadan3 = chetchikWZadan3 + 100;
  Schetchik();}
  if (par3==1) {
  hour3++;
  if (hour3==24||hour3==255) hour3=0; }
  if (par3==2) {
  min3++;
  if (min3==60||min3==255) min3=0; }}  
  } else {
        switch (x) {       
        case 0: {hour++; break;};           
        case 3: {min++; break;};
        case 6: {day++; break;};
        case 9: {month++; break;};
        case 12: {year++; break;}; } 
        
      if (min==60||min==255) {min=0;} 
      if (hour==24||hour==255) {hour=0;}              
  rtc_set_time(hour,min,01);
        if (day==32)   {day=0;} 
        if (month==13) {month=0;}
        if (year==99)  {year=0;}   
  rtc_set_date(week_day,day,month,year);
   kod='?';} break;};    
      
  case '-': { 
  if (menu==0) {   
  if (Revim==2) {       
  if (chetchikWZadan-100 < 0) chetchikWZadan=0; else
  chetchikWZadan = chetchikWZadan - 100;
  Schetchik();}
  
  if (Revim==3) { 
  if (par3==0) {       
  if (chetchikWZadan3-100 < 0) chetchikWZadan3=0; else
  chetchikWZadan3 = chetchikWZadan3 - 100;
  Schetchik(); }
  if (par3==1) {
  hour3--;
  if (hour3==24||hour3==255) hour3=0;}
  if (par3==2){
  min3--;
  if (min3==60||min3==255) min3=0; }  
  } } else {
        switch (x) {       
        case 0: {hour--; break;};           
        case 3: {min--; break;};
        case 6: {day--; break;};
        case 9: {month--; break;};
        case 12: {year--; break;};} 
        
      if (min==60||min==255) {min=0;}
      if (hour==24||hour==255) {hour=0;}              
  rtc_set_time(hour,min,01);
        if (day==32)   {day=0;} 
        if (month==13) {month=0;}
        if (year==99)  {year=0;}   
  rtc_set_date(week_day,day,month,year);
   kod='?';} break;}; }          
}}